/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarryhoalg_19;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 *
 * @author majer
 */
public class Graf 
{
    private int aN; // pocet vrcholov
    private int aM; //pocet hran
    private Vrchol[] aVrcholy;
    private Hrana[] aHrany;

    public Graf(int paPocetVrcholov, int paPocetHran) 
    {
        this.aN = paPocetVrcholov;
        this.aM = paPocetHran;
        aVrcholy = new Vrchol[1+paPocetVrcholov];
        aHrany = new Hrana[1+paPocetHran];
    }
    
    public static Graf nacitajSubor(String paNazovSuboru) 
            throws FileNotFoundException
    {
        Scanner s = new Scanner(new File(paNazovSuboru));
        int pocetVrcholov = s.nextInt();
        int pocetHran = s.nextInt();
        Graf g = new Graf(pocetVrcholov,pocetHran);
        
        for (int i =1; i <= pocetVrcholov; i++)
        {
            g.aVrcholy[i] = new Vrchol(i);
        }
        
        for (int j = 1; j <= pocetHran; j++)
        {
            Vrchol u = g.aVrcholy[s.nextInt()];
            Vrchol v = g.aVrcholy[s.nextInt()];
            g.aHrany[j] = new Hrana(u, v);
        }
        
        return g;
    }
    
    public void tarryhoAlg(int paS)
    {
        for (int i = 1; i <= aN; i++)
        {
            aVrcholy[i].setObjaveny(false);
        }
        
        for (int j = 1; j <= aM; j++)
        {
            aHrany[j].setPrvehoPrichodu(false);
            aHrany[j].setPouzitaSmeromUV(false);
            aHrany[j].setPouzitaSmeromVU(false);
        }

        Vrchol u = aVrcholy[paS];
        u.setObjaveny(true);
        
        while (true)
        {
            Hrana h = najdiHranu(u);
            if (h == null)
            {
                break;
            }
            
            if (h.getU().getCislo() == u.getCislo())
            {
                // smer u -> v
                System.out.println("Vyberam hranu " 
                        + h + " v smere u -> v.");
                h.setPouzitaSmeromUV(true);
                if (!h.getV().isObjaveny())
                {
                    h.getV().setObjaveny(true);
                    h.setPrvehoPrichodu(true);
                }
                u = h.getV();
            }
            else
            {
                // smer v -> u
                System.out.println("Vyberam hranu " 
                        + h + " v opacnom smere v -> u.");
                h.setPouzitaSmeromVU(true);
                if (!h.getU().isObjaveny())
                {
                    h.getU().setObjaveny(true);
                    h.setPrvehoPrichodu(true);
                }
                u = h.getU();
            }
        }
    }
    
    private Hrana najdiHranu(Vrchol paVrchol)
    {
        for (int j = 1; j <= aM; j++)
        {
            Hrana h = aHrany[j];
            if (h.isPrvehoPrichodu())
                continue;
            
            if (h.getU().getCislo() == paVrchol.getCislo() 
                    && !h.isPouzitaSmeromUV())
            {
                return h;
            }
            else if (h.getV().getCislo() == paVrchol.getCislo() 
                    && !h.isPouzitaSmeromVU())
            {
                return h;
            }
        }

        for (int j = 1; j <= aM; j++)
        {
            Hrana h = aHrany[j];
            if (h.getU().getCislo() == paVrchol.getCislo() 
                    && !h.isPouzitaSmeromUV())
            {
                return h;
            }
            else if (h.getV().getCislo() == paVrchol.getCislo() 
                    && !h.isPouzitaSmeromVU())
            {
                return h;
            }
        }

        return null;
    }
}
